import got from 'got'
import { XMLParser } from 'fast-xml-parser'

import RequestHandler from './../../src/runner/requests/requestHandler.js'

/**
 *  RssHandler
 *
 *  request rss from url and parse to object
 *
 *  @author Björn Hase <me@herr-hase.wtf>
 *
 */

class RssHandler extends RequestHandler {

    /**
     *  getting rss feed from url
     *
     *
     */
    async send() {

        const buffer = await got(this.config.url, {
            responseType: 'buffer',
            resolveBodyOnly: true
        })

        const parser = new XMLParser()
        const feed = parser.parse(buffer.toString())

        this.processActions(feed)
    }
}

export default RssHandler
