import Interface from 'es6-interface'

import ActionInterface from './actionInterface.js'
import StateStore from './../stores/state.js'

/**
 *  Single Action to process Data from Remote Server
 *
 *
 *
 */

class Action extends Interface(ActionInterface) {

    /**
     *  
     *
     *  @param {[type]} config
     *  @param {[type]} local
     *  @param {[type]} data
     *  @param {[type]} lastResult
     *
     */
    constructor(config, options, data, lastResult) {
        super()

        this.config = config
        this.options = options
        this.data = data
        this.lastResult = lastResult

        this.stateStore = new StateStore()
        this.state = this.stateStore.findOneByName(this.config.name)
    }
}

export default Action
