import cron from 'node-cron'
import path from 'path'
import dotenv from 'dotenv'

import { loadEnabledConfig } from './helpers/config.js'
import { resolveClassPath } from './helpers/resolver.js'
import { migrateDB, getDB } from './db.js'
import logger from './helpers/logger.js'

// loading config-files from /resources/configs/enabled
const configs = loadEnabledConfig()

// getting .env
dotenv.config({ path: path.join(path.resolve(), '/.env') })

// check if there is any valid config 
if (configs.length === 0) {
    throw new Error('No valid config found!')
}

// running migrate for prepate db
migrateDB()

// let it rain and add schedule for each config a cron and start
configs.forEach(async (config) => {

   // const task = cron.schedule(config.cron, async () => {

        const requestClass = resolveClassPath('requests', config.request.class)

        const RequestClass = await import(requestClass)
        const request = new RequestClass.default(config)

        //try {
            request.send()
       // } catch(error) {
       //     logger.error(error)
       // }

    //})
//
   // task.start()
})
